// TestCallback.cpp : Definiert den Einsprungpunkt fr die Konsolenanwendung.
//

#include "stdafx.h"

typedef int (__cdecl *MYCBPROC) (int);

class A
{
public:
	A() { m_pf = NULL; }
	~A() {}


	void Init(MYCBPROC pf)
	{
		m_pf = pf;
	}

	void Action()
	{
		if(m_pf)
		{
			for(int i=0; i<10; i++)
			{
				int nRet = m_pf(i);
				printf("Return value: %d\n", nRet);
			}

		}
	}

private:

	MYCBPROC m_pf;
};


class B
{
public:
	B() {}
	~B() {}

	void Action()
	{
		A a;
		a.Init(MyFunc);
		a.Action();
	}

	static int MyFunc(int n);
	
};

int B::MyFunc(int n)
{
	return n*n;
}

int main(int argc, char* argv[])
{
	printf("Sample of callback\n\n");
	B b;
	b.Action();
	
	return 0;
}

